// Meltdown2 Vehicles

function VehicleData::mountDriver(%data, %obj, %player)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
   {
        if(!%data.multipassenger)
        {
             %player.startFade(1000, 0, true);
             %player.playShieldEffect("0 0 1");
             %player.setCloaked(true);
             schedule(1000, 0, "testVehicleForMount", %player, %obj);
             %player.schedule(1250,"startFade",1000, 0, false);
             %player.schedule(1250,"setCloaked", false);
        }
   }
}

function FlyingVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function WheeledVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function HoverVehicle::liquidDamage(%obj, %data, %damageAmount, %damageType)
{
   if(%obj.getDamageState() !$= "Destroyed" && !%obj.liquidDamageProof)
   {
      %data.damageObject(%obj, 0, "0 0 0", %damageAmount, %damageType);
      %obj.lDamageSchedule = %obj.schedule(50, "liquidDamage", %data, %damageAmount, %damageType);
      passengerLiquidDamage(%obj, %damageAmount, %damageType);
   }
   else
      %obj.lDamageSchedule = "";
}

function testVehicleForMount(%player, %obj)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
      %player.getDataBlock().onCollision(%player, %obj, 0);
}

function VehicleInfoBar(%obj)
{
     if(isObject(%obj))
     {
          if(%obj.getMountNodeObject(0))
          {
               %obj.ib_hp = (%obj.getDatablock().maxDamage - %obj.getDamageLevel())*100;
               %obj.ib_hp_max = %obj.getDatablock().maxDamage*100;
               %obj.ib_hp_pct = getSubStr(((%obj.ib_hp / %obj.ib_hp_max)*100), 0, 3);
               %obj.ib_vel_ms = velToSingle(%obj.getVelocity());
               %obj.ib_vel_kph = msToKPH(%obj.ib_vel_ms);
               %obj.ib_nrg = %obj.getEnergyLevel();
               %obj.ib_nrg_max = %obj.getDatablock().maxEnergy;
               %obj.ib_nrg_pct = getSubStr(((%obj.ib_nrg / %obj.ib_nrg_max)*100), 0, 3);

//               %obj.ib_s1ammo = %obj.node1Ammo ? %obj.node1AmmoCount : "N/A";
//               %obj.ib_s2ammo = %obj.node2Ammo ? %obj.node2AmmoCount : "N/A";
//               %obj.ib_s3ammo = %obj.node3Ammo ? %obj.node3AmmoCount : "N/A";
//               commandToClient( %obj.getMountNodeObject(0).client, 'BottomPrint', "Structural Integrity: "@%obj.ib_hp_pct@"% | Energy: "@%obj.ib_nrg_pct@"% | Speed: "@%obj.ib_vel_kph@" KPH\nSlot1 Ammo: "@%obj.ib_s1ammo@" | Slot2 Ammo: "@%obj.ib_s2ammo@" | Slot2 Ammo: "@%obj.ib_s2ammo@"\nCurrent selected weapon: "@%obj.selectedWeapon@" ("@, 0.5, 3);
               commandToClient( %obj.getMountNodeObject(0).client, 'BottomPrint', "Integrity: "@%obj.ib_hp_pct@"% | Energy: "@%obj.ib_nrg_pct@"% | Speed: "@%obj.ib_vel_kph@" KPH\n\nCurrent selected weapon: "@%obj.selectedWeapon, 0.5, 3);

               schedule(100, 0, "VehicleInfoBar", %obj);
          }
     }
}
function VehicleData::onDestroyed(%data, %obj, %prevState)
{
    %team = %obj.getControllingClient().team; //%obj.client.team;

    if(%data.canControl)
    {
        %cl = %obj.getControllingClient();
        %cl.setControlObject(%cl.player);
        $TeamDeployedCount[%team, "WildcatPack"]--;
    }

    if(%obj.lastDamagedBy)
    {
        %destroyer = %obj.lastDamagedBy;

        if(!%data.jetfire)
             game.vehicleDestroyed(%obj, %destroyer);
    }

   radiusVehicleExplosion(%data, %obj);
   if(%obj.turretObject)
      if(%obj.turretObject.getControllingClient())
         %obj.turretObject.getDataBlock().playerDismount(%obj.turretObject);

    if(%data.jetfire)
    {
      %obj.prevDest = true;
      %flingee = %obj.getMountNodeObject(0);
      %flingee.damage(0, %obj.getPosition(), 10, $DamageType::Explosion);
      %flingee.getDataBlock().doDismount(%flingee, true);

      %data.deleteAllMounted(%obj);

      if(isObject(%obj))
            %obj.schedule(2000, "delete");

       return;
    }

    if(%data.chair)
    {
      %obj.prevDest = true;
      %flingee = %obj.getMountNodeObject(0);
      %flingee.damage(0, %obj.getPosition(), 10, $DamageType::Default);
      %flingee.getDataBlock().doDismount(%flingee, true);

      %data.deleteAllMounted(%obj);

      if(isObject(%obj))
            %obj.schedule(2000, "delete");

       return;
    }

   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
   {
      echo("damaging objects...");
      if (%obj.getMountNodeObject(%i)) {
         %flingee = %obj.getMountNodeObject(%i);
         %flingee.getDataBlock().doDismount(%flingee, true);
         %xVel = 250.0 - (getRandom() * 500.0);
         %yVel = 250.0 - (getRandom() * 500.0);
         %zVel = (getRandom() * 100.0) + 50.0;
         %flingVel = %xVel @ " " @ %yVel @ " " @ %zVel;
         %flingee.applyImpulse(%flingee.getTransform(), %flingVel);
         echo("got player..." @ %flingee.getClassName());
         %flingee.damage(0, %obj.getPosition(), 0.75, $DamageType::Explosion);
      }
   }

   %data.deleteAllMounted(%obj);
   %obj.schedule(100, "delete");
}

// OnAdd Defs

function ScoutVehicle::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(WildcatChaingunParam, 0);
   %obj.mountImage(WildcatChaingunImage, 2);
   %obj.mountImage(WildcatChaingunPairImage, 3);
   %obj.nextWeaponFire = 2;
   %obj.schedule(6000, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(6300, "playThread", $ActivateThread, "activate");
}

function Skyranger::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(ZigWeaponParam, 0);
   %obj.mountImage(ZigWeaponImage, 2);
   %obj.mountImage(ZigWeaponPairImage, 3);
   %obj.mountImage(ZigQuadGun1, 4);
   %obj.mountImage(ZigQuadGun2, 5);
   %obj.mountImage(ZigQuadGun3, 6);
   %obj.mountImage(ZigQuadGun4, 7);
   %obj.selectedWeapon = 1;
   %obj.schedule(6000, "playShieldEffect", "0.0 0.0 1.0");
}

function PyroXL::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(5700, "playShieldEffect", "0.0 0.0 1.0");
}

function HoverBike::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(HBChaingunParam, 0);
   %obj.mountImage(HBChaingunImage, 2);
   %obj.mountImage(HBChaingunPairImage, 3);
   %obj.mountImage(HBPlasmaImage, 4);
   %obj.mountImage(HBDecal1, 5);
   %obj.mountImage(HBDecal2, 6);
   %obj.selectedWeapon = 2;
   %obj.schedule(5200, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(5300, "playThread", $ActivateThread, "activate");
}

function HAPCFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");
   %obj.schedule(5900, "playShieldEffect", "0.0 0.0 1.0");
}

function SuicideFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.augmented = true;
   %obj.schedule(5800, "playShieldEffect", "0.0 0.0 1.0");
}

function ScoutFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(ScoutChaingunZParam, 0);
   %obj.mountImage(ScoutChaingunZImage, 2);
   %obj.mountImage(ScoutChaingunZPairImage, 3);
   %obj.mountImage(ScoutChaingunParam, 4);
   %obj.mountImage(ScoutChaingunImage, 5);
   %obj.mountImage(ScoutChaingunPairImage, 6);
   %obj.nextWeaponFire = 5;
   %obj.selectedWeapon = 2;
   %obj.schedule(5400, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
   $numVWeapons = 2;
}

function tPOC::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(tPOCCannonParam, 0);
   %obj.mountImage(tPOCCannonImage, 2);
   %obj.mountImage(tPOCCannonPairImage, 3);
   %obj.mountImage(tPOCMissileParam, 4);
   %obj.mountImage(tPOCMissileImage, 5);
   %obj.mountImage(tPOCMissilePairImage, 6);
   %obj.nextWeaponFire = 2;
   %obj.selectedWeapon = 1;
   %obj.schedule(5400, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
   $numVWeapons = 2;
   %obj.augmented = true;
}

function ATV2::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.canWarp = true;
   %obj.mountImage(ScoutChaingunParam, 0);
   %obj.mountImage(ScoutChaingunImage, 2);
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
   %obj.augmented = true;
}

function AssaultVehicle::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);

   %turret = TurretData::create(AssaultPlasmaTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(AssaultPlasmaTurretBarrel, 2);
   %turret.mountImage(AssaultMortarTurretBarrel, 4);
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %obj.turretObject = %turret;

   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);

   //Needed so we can set the turret parameters..
   %turret.mountImage(AssaultTurretParam, 0);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");

   // set the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);

   %obj.mountImage(TankPilotChaingunParam, 5);
   %obj.mountImage(TankPilotChaingunImage, 6);
}

function AlternateMobileBase::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.station = "";
   %obj.turret = "";
   %obj.beacon = "";

   %obj.schedule(5000, "playThread", $AmbientThread, "ambient");
}

function AlternateMobileBase::deleteAllMounted(%data, %obj)
{
   if(%obj.station !$= "")
   {
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.unmountObject(%obj.station);
      %obj.station.trigger.delete();
      %obj.station.delete();
   }
   if(%obj.turret !$= "")
   {
      %obj.turret.getDataBlock().onLosePowerDisabled(%obj.turret);
      %obj.unmountObject(%obj.turret);
      %obj.turret.delete();
   }
   if(isObject(%obj.shield))
      %obj.shield.delete();

   if (isObject(%obj.teleporter))
   {
      %obj.teleporter.setThreadDir($ActivateThread, FALSE);
      %obj.teleporter.playThread($ActivateThread,"activate");
      %obj.teleporter.playAudio($ActivateSound, StationTeleportDeacitvateSound);
   }
   if(isObject(%obj.beacon))
   {
      %obj.beacon.delete();
   }
}

// Player Mounting Calls

function ScoutFlyer::playerMounted(%data, %obj, %player, %node)
{
   // scout flyer == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
   $numVWeapons = 2;

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function tPOC::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
   $numVWeapons = 2;

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function DroneBike::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function Skyranger::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
   $numVWeapons = 2;

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function PyroXL::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
        %obj.owner = %player.client;
        VehicleInfoBar(%obj);
   }
   else
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function ScoutVehicle::playerMounted(%data, %obj, %player, %node)
{
   // scout vehicle == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function HoverBike::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

      if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function SuicideFlyer::playerMounted(%data, %obj, %player, %node)
{
     commandToClient(%player.client, 'setHudMode', 'Pilot', "MPB", %node);
     %obj.owner = %player.client;
     VehicleInfoBar(%obj);
}

function ATV2::playerMounted(%data, %obj, %player, %node)
{
     %obj.stasisProof = true;
   if(%node == 0)
   {
          commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
          %obj.client = %player.client;
   }
   else
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function AlternateMobileBase::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "MPB", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

   if(%obj.deploySchedule)
   {
      %obj.deploySchedule.clear();
      %obj.deploySchedule = "";
   }

   if(%obj.deployed !$= "" && %obj.deployed == 1)
   {
      %obj.setThreadDir($DeployThread, false);
      %obj.playThread($DeployThread,"deploy");
      %obj.playAudio($DeploySound, MobileBaseUndeploySound);
      %obj.station.setThreadDir($DeployThread, false);
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.station.clearSelfPowered();
      %obj.station.goingOut=false;
      %obj.station.notDeployed = 1;
      %obj.station.playAudio($DeploySound, MobileBaseStationUndeploySound);

      if((%turretClient = %obj.turret.getControllingClient()) !$= "")
      {
         CommandToServer( 'resetControlObject', %turretClient );
      }

      %obj.turret.setThreadDir($DeployThread, false);
      %obj.turret.clearTarget();
      %obj.turret.setTargetObject(-1);

      %obj.turret.playAudio($DeploySound, MobileBaseTurretUndeploySound);
      %obj.shield.open();
      %obj.shield.schedule(1000,"delete");
      %obj.deploySchedule = "";

      %obj.teleporter.setThreadDir($ActivateThread, FALSE);
      %obj.teleporter.playThread($ActivateThread,"activate");
      %obj.teleporter.playAudio($ActivateSound, StationTeleportDeacitvateSound);
      %obj.fullyDeployed = 0;

      %obj.noEnemyControl = 0;
   }
   %obj.deployed = 0;

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function AlternateMobileBase::playerDismounted(%data, %obj, %player)
{
   AlternateMobileBase::vehicleDeploy(%data, %obj, %player, true); // SIMPLE AS 3.14
   Parent::playerDismounted( %data, %obj, %player );
}

function AlternateMobileBase::vehicleDeploy(%data, %obj, %player, %force)
{
   if(%obj.ready || %force)
   {
      %deployMessage = "";
      if( (%deployMessage = %data.checkTurretDistance(%obj)) $= "" || %force)
      {
         if(%obj.station $= "")
         {
            if( (%deployMessage = %data.checkDeploy(%obj)) $= "" || %force)
            {
               %obj.station = new StaticShape() {
                  scale = "1 1 1";
                  dataBlock = "MobileInvStation";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
                  vehicle = %obj;
               };
               %obj.station.startFade(0,0,true);
               %obj.mountObject(%obj.station, 2);
               %obj.station.getDataBlock().createTrigger(%obj.station);
               %obj.station.setSelfPowered();
               %obj.station.playThread($PowerThread,"Power");
               %obj.station.playAudio($HumSound,StationHumSound);
               %obj.station.vehicle = %obj;
               %obj.turret = new turret() {
                  scale = "1 1 1";
                  dataBlock = "MobileTurretBase";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
               };
               %obj.turret.setDamageLevel(%obj.getDamageLevel());
               %obj.mountObject(%obj.turret, 1);
               %obj.turret.setSelfPowered();
               %obj.turret.playThread($PowerThread,"Power");
               %obj.turret.mountImage(MissileBarrelLarge, 0 ,false);

               %obj.beacon = new ScopeAlwaysShape() {
                  dataBlock = "DeployedBeacon";
                  position = %obj.position;
                  rotation = %obj.rotation;
                  team = %obj.team;
               };
               %obj.beacon.setBeaconType(friend);
               %obj.beacon.setTarget(%obj.team);
            }
         }
         else
         {
            %obj.station.setSelfPowered();
            %obj.station.playThread($PowerThread,"Power");
            %obj.turret.setSelfPowered();
            %obj.turret.playThread($PowerThread,"Power");
         }
         if(%deployMessage $= "" || %force)
         {
            if(%obj.turret.getTarget() == -1)
            {
               %obj.turret.setTarget(%obj.turret.target);
            }
            %obj.turret.setThreadDir($DeployThread, true);
            %obj.turret.playThread($DeployThread,"deploy");
            %obj.turret.playAudio($DeploySound, MobileBaseTurretDeploySound);

            %obj.station.notDeployed = 1;
            %obj.setThreadDir($DeployThread, true);
            %obj.playThread($DeployThread,"deploy");
            %obj.playAudio($DeploySound, MobileBaseDeploySound);
            %obj.deployed = 1;
            %obj.deploySchedule = "";
            %obj.disableMove = true;
            %obj.setFrozenState(true);
            if(isObject(%obj.shield))
               %obj.shield.delete();

            %obj.shield = new forceFieldBare()
            {
               scale = "1.22 1.8 1.1";
               dataBlock = "defaultTeamSlowFieldBare";
               team = %obj.team;
            };
            %obj.shield.open();
            setTargetSensorData(%obj.getTarget(), MPBDeployedSensor);
         }
      }
      if(%deployMessage !$= "")
         messageClient(%player.client, '', %deployMessage);

      return true;
   }
   else
   {
      return false;
   }
}

function AlternateMobileBase::onEndSequence(%data, %obj, %thread)
{
   if(%thread == $DeployThread && !%obj.deployed)
   {
      %obj.unmountObject(%obj.station);
      %obj.station.trigger.delete();
      %obj.station.delete();
      %obj.station = "";

	  %obj.beacon.delete();

      %obj.unmountObject(%obj.turret);
      %obj.turret.delete();
      %obj.turret = "";

      if(!%obj.immobilized)
      {
         %obj.disableMove = false;
         %obj.setFrozenState(false);
      }
      setTargetSensorData(%obj.getTarget(), %data.sensorData);
   }
   else
   {
      %obj.station.startFade(0,0,false);
      %obj.station.setThreadDir($DeployThread, true);
      %obj.station.playThread($DeployThread,"deploy");
      %obj.station.playAudio($DeploySound, MobileBaseStationDeploySound);
      %obj.station.goingOut = true;
      %obj.shield.setTransform(%obj.getSlotTransform(3));
      %obj.shield.close();
      %obj.isDeployed = true;
      %obj.noEnemyControl = 1;
   }

   Parent::onEndSequence(%data, %obj, %thread);
}

function AlternateMobileBase::checkDeploy(%data, %obj)
{
   %mask = $TypeMasks::VehicleObjectType | $TypeMasks::MoveableObjectType |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType |
           $TypeMasks::ItemObjectType | $TypeMasks::PlayerObjectType |
           $TypeMasks::TurretObjectType | //$TypeMasks::StaticTSObjectType |
           $TypeMasks::InteriorObjectType;

   //%slot 1 = turret   %slot 2 = station
   %height[1] = 0;
   %height[2] = 0;
   %radius[1] = 2.4;
   %radius[2] = 2.4;
   %stationFailed = false;
   %turretFailed = false;

   for(%x = 1; %x < 3; %x++)
   {
      %posXY = getWords(%obj.getSlotTransform(%x), 0, 1);
      %posZ = (getWord(%obj.getSlotTransform(%x), 2) + %height[%x]);
      InitContainerRadiusSearch(%posXY @ " " @ %posZ, %radius[%x], %mask);

      while ((%objFound = ContainerSearchNext()) != 0)
      {
         if(%objFound != %obj)
         {
            if(%x == 1)
               %turretFailed = true;
            else
               %stationFailed = true;
            break;
         }
      }
   }

   //If turret, station or both fail the send back the error message...
   if(%turretFailed &&  %stationFailed)
      return "Both Turret and Station are blocked and unable to deploy.";
   if(%turretFailed)
      return "Turret is blocked and unable to deploy.";
   if(%stationFailed)
      return "Station is blocked and unable to deploy.";

   //Check the station for collision with the Terrain
   %mat = %obj.getTransform();
   for(%x = 1; %x < 7; %x+=2)
   {
      %startPos = MatrixMulPoint(%mat, %data.stationPoints[%x]);
      %endPos = MatrixMulPoint(%mat, %data.stationPoints[%x+1]);

      %rayCastObj = containerRayCast(%startPos, %endPos, $TypeMasks::TerrainObjectType, 0);
      if(%rayCastObj)
         return "Station is blocked by terrain and unable to deploy.";
   }

   return "";
}

function AlternateMobileBase::checkTurretDistance(%data, %obj)
{
   %pos = getWords(%obj.getTransform(), 0, 2);
   InitContainerRadiusSearch(%pos, 50, $TypeMasks::TurretObjectType | $TypeMasks::InteriorObjectType);
   while ((%objFound = ContainerSearchNext()) != 0)
   {
      if(%objFound.getType() & $TypeMasks::TurretObjectType)
      {
         if(%objFound.getDataBlock().ClassName $= "TurretBase")
            return "Turret Base is in the area. Unable to deploy.";
      }
      else
      {
         %subStr = getSubStr(%objFound.interiorFile, 1, 4);
         if(%subStr !$= "rock" && %subStr !$= "spir" && %subStr !$= "misc")
            return "Building is in the area. Unable to deploy.";
      }
   }
   return "";
}

$VehicleMax[ScoutVehicle]     = 10;
$VehicleMax[AssaultVehicle]   = 4;
$VehicleMax[MobileBaseVehicle]= 1;
$VehicleMax[tPOC] = 3;
$VehicleMax[AlternateMobileBase]= 1;
$VehicleMax[ScoutFlyer]       = 6;
$VehicleMax[BomberFlyer]      = 2;
$VehicleMax[HAPCFlyer]        = 3;
$VehicleMax[HoverBike]        = 5;
$VehicleMax[SuicideFlyer]     = 1;
$VehicleMax[PyroXL]           = 3;
//$VehicleMax[DroneBike]        = 15;
$VehicleMax[Skyranger]        = 3;
$VehicleMax[ATV2]             = 999;

function clearVehicleCount(%team)
{
   $VehicleTotalCount[%team, ScoutVehicle]      = 0;
   $VehicleTotalCount[%team, AssaultVehicle]    = 0;
   $VehicleTotalCount[%team, MobileBaseVehicle] = 0;
   $VehicleTotalCount[%team, ScoutFlyer]        = 0;
   $VehicleTotalCount[%team, BomberFlyer]       = 0;
   $VehicleTotalCount[%team, HAPCFlyer]         = 0;
   $VehicleTotalCount[%team, HoverBike]         = 0;
   $VehicleTotalCount[%team, ATV]           = 0;
   $VehicleTotalCount[%team, SuicideFlyer]       = 0;
   $VehicleTotalCount[%team, PyroXL]       = 0;
   $VehicleTotalCount[%team, DroneBike]       = 0;
   $VehicleTotalCount[%team, Skyranger]       = 0;
   $VehicleTotalCount[%team, ATV2]       = 0;
   $VehicleTotalCount[%team, tPOC]        = 0;
}

function findEmptySeat(%vehicle, %player, %forceNode)
{
   %minNode = 1;
   %node = -1;
   %dataBlock = %vehicle.getDataBlock();
   %dis = %dataBlock.minMountDist;
   %playerPos = getWords(%player.getTransform(), 0, 2);
   %message = "";
   if(%dataBlock.lightOnly)
   {
      if(%player.client.armor $= "Light")
         %minNode = 0;
      else
         %message = '\c2Only Scout Armors can pilot this vehicle.~wfx/misc/misc.error.wav';
   }
//   else if(%dataBlock.jetfire)
//   {
//      if(%player.client.armor $= "Medium")
//         %minNode = 0;
//      else
//         %message = '\c2THIS WAS NOT SUPPOSED TO HAPPEN!!!.~wfx/misc/misc.error.wav';
//   }
   else if(%player.client.armor $= "Light" || %player.client.armor $= "Medium" || %player.client.armor $= "Engineer" || %player.client.armor $= "Blastech")
      %minNode = 0;
   else if(!%player.getDatablock().isBattleAngel)
      %minNode = findFirstHeavyNode(%dataBlock);

   if(%forceNode !$= "")
      %node = %forceNode;
   else
   {
      for(%i = 0; %i < %dataBlock.numMountPoints; %i++)
         if(!%vehicle.getMountNodeObject(%i))
         {
            %seatPos = getWords(%vehicle.getSlotTransform(%i), 0, 2);
            %disTemp = VectorLen(VectorSub(%seatPos, %playerPos));
            if(%disTemp <= %dis)
            {
               %node = %i;
               %dis = %disTemp;
            }
         }
    }
   if(%node != -1 && %node < %minNode)
   {
      if(%message $= "")
      {
         if(%node == 0)
            %message = '\c2Only Scout, Engineer or Assault Armors can pilot this vehicle.~wfx/misc/misc.error.wav';
         else
            %message = '\c2Only Scout, Engineer or Assault Armors can use that position.~wfx/misc/misc.error.wav';
      }

      if(!%player.noSitMessage)
      {
         %player.noSitMessage = true;
         %player.schedule(2000, "resetSitMessage");
         messageClient(%player.client, 'MsgArmorCantMountVehicle', %message);
      }
      %node = -1;
   }
   return %node;
}

function Armor::doDismount(%this, %obj, %forced)
{
   // This function is called by player.cc when the jump trigger
   // is true while mounted
   if (!%obj.isMounted())
      return;

   if(isObject(%obj.getObjectMount().shield))
      %obj.getObjectMount().shield.delete();

   commandToClient(%obj.client,'SetDefaultVehicleKeys', false);

   // Position above dismount point

   %pos    = getWords(%obj.getTransform(), 0, 2);
   %oldPos = %pos;
   %vec[0] = " 0  0  1";
   %vec[1] = " 0  0  1";
   %vec[2] = " 0  0 -1";
   %vec[3] = " 1  0  0";
   %vec[4] = "-1  0  0";
   %numAttempts = 5;
   %success     = -1;
   %impulseVec  = "0 0 0";
   if (%obj.getObjectMount().getDatablock().hasDismountOverrides() == true)
   {
      %vec[0] = %obj.getObjectMount().getDatablock().getDismountOverride(%obj.getObjectMount(), %obj);
      %vec[0] = MatrixMulVector(%obj.getObjectMount().getTransform(), %vec[0]);
   }
   else
   {
      %vec[0] = MatrixMulVector( %obj.getTransform(), %vec[0]);
   }

   %pos = "0 0 0";
   for (%i = 0; %i < %numAttempts; %i++)
   {
      %pos = VectorAdd(%oldPos, VectorScale(%vec[%i], 3));
      if (%obj.checkDismountPoint(%oldPos, %pos))
      {
         %success = %i;
         %impulseVec = %vec[%i];
         break;
      }
   }
   if (%forced && %success == -1)
   {
      %pos = %oldPos;
   }

   // hide the dashboard HUD and delete elements based on node
   commandToClient(%obj.client, 'setHudMode', 'Standard', "", 0);
   // Unmount and control body
   if(%obj.vehicleTurret)
      %obj.vehicleTurret.getDataBlock().playerDismount(%obj.vehicleTurret);
   %obj.unmount();
   if(%obj.mVehicle)
      %obj.mVehicle.getDataBlock().playerDismounted(%obj.mVehicle, %obj);

   // bots don't change their control objects when in vehicles
   if(!%obj.client.isAIControlled())
   {
      %vehicle = %obj.getControlObject();
      %obj.setControlObject(0);
   }

   %obj.mountVehicle = false;
   %obj.schedule(2000, "setMountVehicle", true);

   // Position above dismount point
   %obj.setTransform(%pos);
   %obj.playAudio(0, UnmountVehicleSound);
   %obj.applyImpulse(%pos, VectorScale(%impulseVec, %obj.getDataBlock().mass * 3));
   %obj.setPilot(false);
   %obj.vehicleTurret = "";
}

function fireNextGum(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == 5)
      {
         %obj.setImageTrigger(5, true);
         %obj.setImageTrigger(6, false);
      }
      else
      {
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, true);
      }
   }
   else
   {
      %obj.setImageTrigger(5, false);
      %obj.setImageTrigger(6, false);
   }
}

function fireNexttPOC(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.MissileFired == 1)
      {
         %obj.setImageTrigger(5, true);
         %obj.setImageTrigger(6, false);
      }
      else if(%obj.MissileFired == 2)
      {
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, true);
      }
   }
   else
   {
      %obj.setImageTrigger(5, false);
      %obj.setImageTrigger(6, false);
   }
}

function fireNextGun(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == 2)
      {
         %obj.setImageTrigger(2, true);
         %obj.setImageTrigger(3, false);
      }
      else
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, true);
      }
   }
   else
   {
      %obj.setImageTrigger(2, false);
      %obj.setImageTrigger(3, false);
   }
}

