//================ EMP / Fire / Burn code
// Loops in 100ms chunks
// Similar (was going to do an all-in-one) but they have their own unique features.

$LDO::LifetimeMS = 100;

$BurnDamageMS = 0.01;
$BrnDamageMS = 0.0025;
$PoisonDamageMS = 0.01;

datablock ParticleData(StarburstFlameParticle)
{
    dragCoefficient = 0;
    gravityCoefficient = 0.3;
    windCoefficient = 0;
    inheritedVelFactor = 0.362903;
    constantAcceleration = 0;
    lifetimeMS = 750;
    lifetimeVarianceMS = 750;
    useInvAlpha = 0;
    spinRandomMin = -145.161;
    spinRandomMax = 133.065;
    textureName = "special/tracer00.PNG";
    times[0] = 0;
    times[1] = 1;
    colors[0] = "0.850394 0.304000 0.192000 0.451613";
    colors[1] = "0.000000 0.000000 0.000000 0.709677";
    sizes[0] = 1.97581;
    sizes[1] = 1.35484;
};

datablock ParticleEmitterData(StarburstFlameEmitter)
{
    ejectionPeriodMS = 15;
    periodVarianceMS = 0;
    ejectionVelocity = 5.79032;
    velocityVariance = 2.30645;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 14.5161;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "StarburstFlameParticle";
};

datablock ParticleData(PCRSparkParticle)
{
    dragCoefficient = 0.707317;
    gravityCoefficient = 0;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = 0;
    lifetimeMS = 500;
    lifetimeVarianceMS = 350;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/bigspark";
    times[0] = 0;
    times[1] = 0.5;
    times[2] = 1;
    colors[0] = "0.314961 1.000000 0.576000 1.000000";
    colors[1] = "0.560000 0.360000 0.260000 1.000000";
    colors[2] = "1.000000 0.360000 0.260000 0.000000";
    sizes[0] = 2.31452;
    sizes[1] = 0.25;
    sizes[2] = 0.25;
};

datablock ParticleEmitterData(PCRSparkEmitter)
{
    ejectionPeriodMS = 3;
    periodVarianceMS = 0;
    ejectionVelocity = 18;
    velocityVariance = 6.75;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 180;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
   lifeTimeMS = 200;
    orientParticles= 1;
    orientOnVelocity = 1;
    particles = "PCRSparkParticle";
};

datablock ParticleData(EMPSparksParticle)
{
    dragCoefficient = 0.6;
    gravityCoefficient = 0;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = 0;
    lifetimeMS = 650;
    lifetimeVarianceMS = 325;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/bigspark";
    times[0] = 0;
    times[1] = 0.5;
    times[2] = 1;
    colors[0] = "0.100000 0.100000 1.000000 1.000000";
    colors[1] = "0.050000 0.050000 1.000000 1.000000";
    colors[2] = "0.000000 0.000000 1.000000 0.000000";
    sizes[0] = 2.31452;
    sizes[1] = 0.25;
    sizes[2] = 0.25;
};

datablock ParticleEmitterData(EMPSparksEmitter)
{
    ejectionPeriodMS = 3;
    periodVarianceMS = 0;
    ejectionVelocity = 18;
    velocityVariance = 6.75;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 180;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
   lifeTimeMS = 200;
    orientParticles= 1;
    orientOnVelocity = 1;
    particles = "EMPSparksParticle";
};


function ShapeBase::finishedDamaging(%obj)
{
     finishedDamaging(%obj);
}

function ShapeBase::EMPObject(%obj)
{
     EMPObject(%obj);
}

function ShapeBase::BurnObject(%obj)
{
     BurnObject(%obj);
}

function ShapeBase::PoisonObject(%obj)
{
     PoisonObject(%obj);
}

function enterWaterClearIncen(%obj)
{
     if(isObject(%obj) && %obj.isFlaming)
          %obj.burnTime = 1;
}

function loopDamageObject(%obj)
{
     if(isObject(%obj))
     {
          if(%obj.isEMP)
          {
               if(%obj.EMPTime > 1)
               {
                    %obj.EMPTime -= 1;
                    %obj.setEnergyLevel(0);
                    %obj.EMPEmitter = createLifeEmitter(%obj.getWorldBoxCenter(), "EMPSparksEmitter", $LDO::LifetimeMS);
               }
               else return %obj.finishedDamaging();
          }
          else if(%obj.isFlaming)
          {
             if(%obj.isWet)
               return %obj.finishedDamaging();

               if(%obj.burnTime > 1)
               {
                    %obj.burnTime -= 1;
                    %obj.damage(%obj.LDSrcObj, %obj.getWorldBoxCenter(), $BurnDamageMS, $DamageType::Plasma);
                    %obj.setHeat(1);
                    %obj.IncenFireEmitter = createLifeEmitter(%obj.getWorldBoxCenter(), "StarburstFlameEmitter", $LDO::LifetimeMS);
                    %obj.IncenSmokeEmitter = createLifeEmitter(%obj.getWorldBoxCenter(), "HeavyDamageSmoke", $LDO::LifetimeMS);
               }
               else return %obj.finishedDamaging();
          }
          else if(%obj.isPoisoned)
          {
               if(%obj.poisonTime > 1)
               {
                    if(%obj.getDataBlock().className $= "Armor")
                    {
                         %obj.PoisonTime -= 1;
                         %obj.damage(%obj.LDSrcObj, %obj.getWorldBoxCenter(), $BurnDamageMS, $DamageType::vRocket);
                    }
               }
               else return %obj.finishedDamaging();
          }
          schedule($LDO::LifetimeMS, %obj, "loopDamageObject", %obj);
     }
     else
     {
           %obj.isEMP = false;
           %obj.EMPTime = 1;
           %obj.isFlaming = false;
           %obj.burnTime = 1;
     }
}

function finishedDamaging(%obj)
{
     if(%obj.isEMP)
     {
          %obj.isEMP = false;
          %obj.EMPTime = 0;

          if(%obj.getDataBlock().className $= "Armor")
          {
               if(%obj.client.player == %obj)
                  messageClient(%obj.client, 'msgDoneEMP', '\c2Armor Reactor back on-line.');
          }
     }
     else if(%obj.isFlaming)
     {
          %obj.isFlaming = false;
          %obj.burnTime = 0;

          if(%obj.getDataBlock().className $= "Armor")
          {
               if(%obj.client.player == %obj)
                  messageClient(%obj.client, 'msgDoneBurn', '\c2You have stopped burning.');
          }
     }
     else if(%obj.isPoisoned)
     {
          %obj.isPoisoned = false;
          %obj.poisonTime = 0;

          if(%obj.getDataBlock().className $= "Armor")
          {
               if(%obj.client.player == %obj)
                  messageClient(%obj.client, 'msgDonePoison', '\c2You have been cured of your infection.');
          }
     }
     else
     {
          %obj.isEMP = false;
          %obj.EMPTime = 0;
          %obj.isFlaming = false;
          %obj.burnTime = 0;
          return;
     }
}

function EMPObject(%obj)
{
     if(isObject(%obj) && !%obj.isSyn)
     {
          if(%obj.isEMP)
          {
               if(%obj.EMPTime > 2)
               {
                    %obj.EMPTime += 50;

                    if(%obj.getDataBlock().className $= "Armor")
                         messageClient(%obj.client, 'msgMoreEMP', '\c2You have taken more EMP damage.');

                    return;
               }
          }
          else
          {
               if(%obj.getDataBlock().className $= "Armor")
                   messageClient(%obj.client, 'msgInitEMP', '\c2Error! Armor Power Core Offine.');

//               %obj.setRechargeRate(0);
               %obj.setEnergyLevel(0);
               %obj.isEMP = true;

               if(%obj.getDataBlock().className $= "Armor")
                   %obj.EMPTime = 100;
               else
                   %obj.EMPTime = 250;

               %obj.EMPEmitter = createLifeEmitter(%obj.getWorldBoxCenter(), "PCRSparkEmitter", $LDO::LifetimeMS0);

               loopDamageObject(%obj);
          }
     }
}

function BurnObject(%obj, %attacker)
{
     if(isObject(%obj))
     {
        if(%obj.isWet)
           return;

          if(%obj.isFlaming)
          {
               if(%obj.burnTime > 2)
               {
                    %obj.burnTime += 20;
                    if(%obj.getDataBlock().className $= "Armor")
                         messageClient(%obj.client, 'msgMoreBurn', '\c2You are heating up.');
                    return;
               }
          }
          else
          {
               if(%obj.getDataBlock().className $= "Armor")
                    messageClient(%obj.client, 'msgInitBurn', '\c2You are on fire.');
               %obj.isFlaming = true;
               %obj.burnTime = 200;

               if(%obj.getDataBlock().className $= "Armor")
                    %obj.dmgPct = 0.01;
               else
                    %obj.dmgPct = 0.0025;

               %obj.LDSrcObj = %attacker;
               %obj.IncenFireEmitter = createLifeEmitter(%obj.getWorldBoxCenter(), "StarburstFlameEmitter", $LDO::LifetimeMS); // "LoopDMGFireEmitter"
               %obj.IncenSmokeEmitter = createLifeEmitter(%obj.getWorldBoxCenter(), "HeavyDamageSmoke", $LDO::LifetimeMS);
               loopDamageObject(%obj);
          }
     }
}

function PoisonObject(%obj, %attacker)
{
     if(isObject(%obj))
     {
          if(%obj.isPoisoned)
          {
               if(%obj.getDataBlock().className $= "Armor")  // LOL
               {
                    if(%obj.PoisonTime > 2)
                    {
                         %obj.PoisonTime += 250;
                         if(%obj.getDataBlock().className $= "Armor")
                              messageClient(%obj.client, 'msgMorePoison', '\c2You recieved another infectious wound.');
                         return;
                    }
               }
          }
          else
          {
               if(%obj.getDataBlock().className $= "Armor")  // LOL
               {
                    if(%obj.getDataBlock().className $= "Armor")
                         messageClient(%obj.client, 'msgInitPoison', '\c2You recieved a poisonious wound.');

                    %obj.isPoisoned = true;
                    %obj.PoisonTime = 250;
                    %obj.LDSrcObj = %attacker;
                    loopDamageObject(%obj);
               }
          }
     }
}

function loopDamageFX(%obj, %radius, %count, %rate, %blocktype, %block)
{
   if(%blocktype $= "" || %block $= "")
      return;

   if(%rate < 0.1)
      %rate = 1;

   if(%obj.DFX_Count <= %count && %obj)
   {
      %pos = %obj.getPosition();
      %px = getWord(%pos, 0) + getRandomT(%radius);
      %py = getWord(%pos, 1) + getRandomT(%radius);
      %pz = getWord(%pos, 2) + getRandomT(%radius);
      %npos = %px SPC %py SPC %pz;

      %p = new (%blocktype)() {
         dataBlock        = %block;
         initialDirection = "0 0 0";
         initialPosition  = %npos;
         sourceObject     = %obj;
         sourceSlot       = 0;
      };
      MissionCleanup.add(%p);

      %obj.DFX_Count++;

      schedule((1/%rate)*1000, 0, "loopDamageFX", %obj, %radius, %count, %rate, %blocktype, %block);
   }
   else
      %obj.DFX_Count = 0;
}

