// ------------------------------------------------------------------

datablock AudioProfile(JetfireTransform)
{
	filename = "fx/powered/inv_pad_off.wav";
	description = AudioDefault3d;
    preload = true;
};

datablock ShapeBaseImageData(JetfirePackImage)
{
   shapeFile = "pack_barrel_elf.dts";
   item = JetfirePack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = -1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = JetfireTransform;
//   stateEnergyDrain[1] = 9;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(JetfirePack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_barrel_elf.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "JetfirePackImage";
	pickUpName = "a jetfire pack";
};

function JetfirePackImage::onMount(%data, %obj, %node)
{
}

function JetfirePackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
}

datablock ShapeBaseImageData(TransChaingunImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item      = Chaingun;
   projectile = ScoutChaingunBullet;
   projectileType = TracerProjectile;
   mountPoint = 10;       //?
   offset = "0 0 -0.2";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 5;
   fireEnergy = 2;
   fireTimeout = 200;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4] = ShrikeBlasterFire;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.2;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};


datablock ShapeBaseImageData(TransChaingunParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = VehicleMitziBlast;
   projectileType = LinearFlareProjectile;
};

datablock FlyingVehicleData(JetFire) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";
   multipassenger = false;

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   cameraMaxDist = 10.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   jetFire = 1;

   mountPose[0] = sitting;
   maxDamage = 1.0;
   destroyedLevel = 1.0;

   isShielded = false;
   energyPerDamagePoint = 75;
   maxEnergy = 110;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.256;

   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 400;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds
   maxForwardSpeed = 100;

   // Maneuvering
   maxSteeringAngle = 4;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 8;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 6;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 16.4 * 150;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1200;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 550;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 2;        // Height off the ground at rest
   createHoverHeight = 2;  // Height off the ground when created

   // Turbo Jet
   jetForce = 32 * 150 * 2.0;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 1;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 1.1;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 1.5;

   // Rigid body
   mass = 180;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 35;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 55;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 40;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.06;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0;
   collDamageMultiplier   = 0.02;

   //
   minTrailSpeed = 999;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = FlyerJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = ArmorJetSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 15.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Jetfire';
   targetTypeTag = 'Transformer';
   sensorData = VehiclePulseSensor;

   runningLight[0] = ShrikeLight1;

   shieldEffectScale = "0.937 1.125 0.60";
};

function Jetfire::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(TransChaingunParam, 0);
   %obj.mountImage(TransChaingunImage, 2);
   %obj.nextWeaponFire = 2;
   %obj.schedule(50, "playThread", $ActivateThread, "activate");
}

function Jetfire::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);

      if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function JetFire::onTrigger(%data, %obj, %trigger, %state)     // there.
{
     if(%trigger == 0)
     {
          switch(%state)
          {
               case 0:
                    %obj.fireWeapon = false;
                    %obj.setImageTrigger(2, false);
               case 1:
                    %obj.fireWeapon = true;
                    %obj.setImageTrigger(2, true);
          }
     }
}

function JetFire::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
   jetfireDisable(%player, %obj);
}

function cantJetfire(%pl)
{
     InitContainerRadiusSearch(%pl.getPosition(), 10, $TypeMasks::InteriorObjectType);

     while ((%int = ContainerSearchNext()) != 0)
     {
         %subStr = getSubStr(%int.interiorFile, 1, 4);
         if(%subStr !$= "rock" && %subStr !$= "spir" && %subStr !$= "misc")
            return true;
     }
}

function jetfireEnable(%pl)
{
  if(!cantJetfire(%pl))
  {
     %pl.startFade(100, 0, true);

      %vehicle = new FlyingVehicle()
      {
         dataBlock  = "Jetfire";
         respawn    = "0";
         teamBought = %pl.client.Team;
         team = %pl.client.Team;
      };

      %vehicle.setTransform(modifyTransform(%pl.getTransform(), "0 0 1.5 0 0 0 0"));
      %pl.getDataBlock().onCollision(%pl, %vehicle, 0);
      %data = %vehicle.getDatablock();
      serverPlay3D("JetfireTransform", %pl.getTransform());

     %dmg = getDamagePercent(%pl.getDatablock().maxDamage, %pl.getDamageLevel());
     %vehicle.setDamageLevel(%dmg * %vehicle.getDatablock().maxDamage);
   
   if((%data.sensorData !$= "") && (%vehicle.getTarget() != -1))
      setTargetSensorData(%vehicle.getTarget(), %data.sensorData);
   %vehicle.setRechargeRate(%data.rechargeRate);
   %vehicle.setEnergyLevel(%pl.getEnergylevel());

   if(%vehicle.mountable || %vehicle.mountable $= "")
      %data.isMountable(%vehicle, true);
   else
      %data.isMountable(%vehicle, false);

     %vehicle.setSelfPowered();

     %vehicle.team = %plyr.client.Team;
     %vehicle.owner = %plyr.client;
     MissionCleanup.add(%vehicle);
   }
   else
        messageClient(%obj.client, 'MsgNoJetfireInside', '\c2You cannot transform on, near or in a building or structure.');
}

function jetfireDisable(%pl, %vehicle)
{
   if(!%vehicle.prevDest)
   {
     %pl.startFade(100, 0, false);
     %pl.setTransform(%vehicle.getTransform());
     %pl.setEnergyLevel(%vehicle.getEnergyLevel());
     %dmg = getDamagePercent(%vehicle.getDatablock().maxDamage, %vehicle.getDamageLevel());
     %pl.setDamageLevel(%dmg * %pl.getDatablock().maxDamage);
     
     %vehicle.setTransform("10000 10000 10000 1 0 0 0");
     %vehicle.applyDamage(10000);
     %vehicle.delete();
     serverPlay3D("JetfireTransform", %pl.getTransform());
     %pl.setImageTrigger(2,false);
     messageClient(%pl.client, 'MsgjetfireOff', '\c2JetfireTransform() -> Bipedal');
   }
}

function JetfirePackImage::onActivate(%data, %obj, %slot)
{
  if(!cantJetfire(%obj))
  {
        messageClient(%obj.client, 'MsgJetfireOn', '\c2JetfireTransform() -> Vehicle');
        jetfireEnable(%obj);
  }
  else
  {
        messageClient(%obj.client, 'MsgJetfireBldg', '\c2You cannot deploy a jetfire on/near/in a building for at least 10m');
        %obj.setImageTrigger(%slot,false);
  }
}

function JetfirePackImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger(%slot,false);
}

function JetfirePack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

