// ------------------------------------------------------------------
// SuperSpeed PACK

datablock AudioProfile(SuperSpeedPackActivateSound)
{
   filename    = "fx/vehicles/tank_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock ShapeBaseImageData(SuperSpeedPackImage)
{
   shapeFile = "pack_upgrade_energy.dts";
   item = SuperSpeedPack;
   mountPoint = 1;
   offset = "0 0 0";
   rotation = "0 1 0 180";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = SuperSpeedPackActivateSound;
   stateEnergyDrain[1] = 15;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(SuperSpeedPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_energy.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "SuperSpeedPackImage";
	pickUpName = "a SuperSpeed pack";
};

function SuperSpeed(%obj)
{
     if(%obj.SuperSpeeding)
     {
          if(velToSingle(%obj.getVelocity()) > 1)
          {
               %vec = %obj.getForwardVector();
               %force = %obj.getDatablock().mass * 5;
               %newVec = VectorScale(%vec, %force);
               %obj.applyImpulse(%obj.getTransform(), %newVec);

               %vel = %obj.getVelocity();
               %vx = getWord(%vel, 0);
               %vy = getWord(%vel, 1);
               %vz = getWord(%vel, 2);
                    if(%vx > 25)
                         %vx = 25;
                    if(%vy > 25)
                         %vy = 25;
               %nVel = %vx@" "@%vy@" "@%vz;
               %obj.setVelocity(%nVel);
          }
          
          schedule(100, 0, "SuperSpeed", %obj);
     }
}

function SuperSpeedPackImage::onMount(%data, %obj, %node)
{
}

function SuperSpeedPackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
   %obj.SuperSpeeding = "";
}

function SuperSpeedPackImage::onActivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgSuperSpeedPackOn', '\c2SuperSpeed pack on.');
   %obj.SuperSpeeding = true;
   SuperSpeed(%obj);
}

function SuperSpeedPackImage::onDeactivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgSuperSpeedPackOff', '\c2SuperSpeed pack off.');
	%obj.setImageTrigger(%slot,false);
   %obj.SuperSpeeding = "";
}

function SuperSpeedPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

