// ------------------------------------------------------------------
// Slipstream IX Pack

datablock AudioProfile(SlipstreamWarp)
{
	filename = "fx/weapons/chaingun_start.wav";
	description = AudioDefault3D;
    preload = true;
};

datablock AudioProfile(oldTeleOff)
{
	filename = "fx/weapons/chaingun_off.wav";
	description = AudioDefault3D;
    preload = true;
};

datablock ShapeBaseImageData(SlipstreamPackImage)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   item = SlipstreamPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = -1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = SynomiumIdle;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(SlipstreamPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_sensorjammer.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "SlipstreamPackImage";
	pickUpName = "a slipstream-ix";

};

function slipstreamTeleport(%obj)
{
     messageClient(%obj.client, 'MsgSlipStOn', '\c2Slipstream-IX teleported to waypoint beacon.');
     %obj.setPosition(%obj.client.slipbeacon.getPosition());
     %obj.teleportEndFX();
     %obj.client.slipbeacon.delete();
     %obj.client.slipbeacon = "";
     %obj.useEnergy(50);
}

function SlipstreamPackImage::onMount(%data, %obj, %node)
{
     Parent::onMount(%data, %obj, %node);
}

function SlipstreamPackImage::onUnmount(%data, %obj, %node)
{
     if(%obj.client.slipbeacon)
     {
          %obj.client.slipbeacon.delete();
          %obj.client.slipbeacon = "";
     }
}

function SlipstreamPackImage::onActivate(%data, %obj, %slot)
{
     if(%obj.client.slipbeacon)
     {
          if(getObjectDistance(%obj.client.slipbeacon, %obj) < 400)
          {
               if(%obj.getEnergyLevel() > 50)
               {
                    %obj.teleportStartFX();
                    schedule(1500, 0, "slipstreamTeleport", %obj);
               	%obj.setImageTrigger(%slot,false);
               }
               else
               {
                    messageClient(%obj.client, 'MsgSlipStFailNRG', '\c2Slipstream-IX does not have enough energy to teleport.');
               	%obj.setImageTrigger(%slot,false);
               }
          }
          else
          {
               messageClient(%obj.client, 'MsgSlipStFail', '\c2Slipstream-IX out of range.');
          	%obj.setImageTrigger(%slot,false);
          }
     }
     else
     {
          if(%obj.getEnergyLevel() > 25)
          {
               messageClient(%obj.client, 'MsgSlipStCreateBeacon', '\c2Slipstream-IX teleport beacon created.');
               %obj.useEnergy(25);
               %obj.client.slipbeacon = new WayPoint()
               {
                   position = %obj.getWorldBoxCenter();
                   rotation = "1 0 0 0";
                   scale = "1 1 1";
                   name = "Slipstream-IX Marker "@getField(%obj.client.getAuthInfo(), 0);
                   dataBlock = "WayPointMarker";
                   lockCount = "0";
                   homingCount = "0";
                   team = %obj.client.team;
               };
               MissionCleanup.add(%obj.client.slipbeacon);

          	%obj.setImageTrigger(%slot,false);
          }
          else
          {
               messageClient(%obj.client, 'MsgSlipStFailBeacon', '\c2Slipstream-IX does not have enough energy to create a teleport beacon.');
          	%obj.setImageTrigger(%slot,false);
          }
     }
}

function SlipstreamPackImage::onDeactivate(%data, %obj, %slot)
{
//     messageClient(%obj.client, 'MsgSlipStOff', '\c2Slipstttream-IX Disabled.');
	%obj.setImageTrigger(%slot,false);
}

function SlipstreamPackImage::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

