// ------------------------------------------------------------------
// Synomium Pack

datablock AudioProfile(SynomiumIdle)
{
	filename = "fx/misc/nexus_idle.wav";
	description = ClosestLooping3d;
    preload = true;
};

datablock AudioProfile(SynomiumEngage)
{
	filename = "fx/weapons/chaingun_start.wav";
	description = AudioDefault3D;
    preload = true;
};

datablock AudioProfile(SynomiumOff)
{
	filename = "fx/weapons/chaingun_off.wav";
	description = AudioDefault3D;
    preload = true;
};

datablock ShapeBaseImageData(SynomiumPackImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   item = SynomiumPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = -1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = SynomiumIdle;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(SynomiumPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "SynomiumPackImage";
	pickUpName = "a synomium device";

};

function synPhase2(%obj)
{
     if(%obj.isSyn)
     {
          %obj.ib_hp = (%obj.getDatablock().maxDamage - %obj.getDamageLevel())*100;
          %obj.ib_hp_max = %obj.getDatablock().maxDamage*100;
          %obj.ib_hp_pct = (%obj.ib_hp / %obj.ib_hp_max)*100;
          %obj.ib_vel_ms = velToSingle(%obj.getVelocity());
          %obj.ib_vel_kph = msToKPH(%obj.ib_vel_ms);
          %obj.ib_nrg = %obj.getEnergyLevel();
          %obj.ib_nrg_max = %obj.getDatablock().maxEnergy;
          %obj.ib_nrg_pct = (%obj.ib_nrg / %obj.ib_nrg_max)*100;

          %obj.setRechargeRate(0.32);
          %obj.hasEnergyPack = true;
          %obj.enPack = true;
          %obj.zapObject();
          
          if(%obj.client.infoBar)
               commandToClient( %obj.client, 'BottomPrint', ">> Synomium Device Self-info bar <<\nHP: "@%obj.ib_hp@"/"@%obj.ib_hp_max@" ("@%obj.ib_hp_pct@"%) | Energy: "@%obj.ib_nrg@"/"@%obj.ib_nrg_max@" ("@%obj.ib_nrg_pct@"%)\nSpeed: "@%obj.ib_vel_ms@" m/s ("@%obj.ib_vel_kph@" KPH)", 0.5, 3);
               
          schedule(100, 0, "synPhase2", %obj);
     }
     else
     {
          %obj.hasEnergyPack = false;
          %obj.enPack = false;
          %obj.setRechargeRate(0.256);
     }
}

function synomise(%obj)
{
     if(%obj.isSyn)
          schedule(1000, 0, "synPhase2", %obj);
}

function SynomiumPackImage::onMount(%data, %obj, %node)
{
     %obj.isSyn = false;
}

function SynomiumPackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
     %obj.isSyn = false;
}

function SynomiumPackImage::onActivate(%data, %obj, %slot)
{
     messageClient(%obj.client, 'MsgShieldPackOn', '\c2Synomium Device Engaged.');
     %obj.play3D(SynomiumEngage);
     %obj.isSyn = true;
     %obj.playShieldEffect("0 0 1");
     synomise(%obj);
}

function SynomiumPackImage::onDeactivate(%data, %obj, %slot)
{
     messageClient(%obj.client, 'MsgShieldPackOff', '\c2Synomium Device Deactivated.');
	%obj.setImageTrigger(%slot,false);
     %obj.play3D(SynomiumOff);
     %obj.isSyn = false;
     %obj.playShieldEffect("0 0 1");
     %obj.stopZap();
}

function SynomiumPackImage::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

