//--------------------------------------------------------------------------
// Sensor Jammer Module
//--------------------------------------------------------------------------

datablock ShapeBaseImageData(SensorJamModImage)
{
   mass = 0;

   shapeFile  = "pack_barrel_missile.dts";
   item       = SensorJamMod;
   mountPoint = 1;
   offset     = "0 0 0";

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeOut[2] = "Idle";

	isLarge = true;
};

datablock ItemData(SensorJamMod)
{
   className    = Pack;
   catagory     = "Packs";
   shapeFile    = "pack_barrel_missile.dts";
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
   rotate       = true;
   image        = "SensorJamModImage";
	pickUpName = "a battery";
};

function SensorJamModImage::onActivate(%data, %obj, %slot)
{
   // search for a vehicle in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a vehicle base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);

   if(%potVehicle != 0)    // positon of the vehicle
   {
          if(%potVehicle.augmented != true)
          {
             // Not already augmented...
		   messageClient(%obj.client, 'MsgAugMount', "\c2Sensorjammer Module Actiated -> "@ %potVehicle.getDatablock().getName() @"...");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
             SensorJamMod::ApplyMod(%data, %obj, %potVehicle);
          }
          else
          {
             messageClient(%obj.client, 'MsgNotVehicle', "\c2Error! This vehicle has already been augmented.");
             %obj.setImageTrigger($BackpackSlot, false);
          }
   }
   else
   {
      // I don't see any vehicle
      messageClient(%obj.client, 'MsgNoVehicle', "\c2No vehicle within the 5m range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

function SensorJamModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function SensorJamMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

datablock SensorData(VehicleJammerSensor)
{
   detects = true;
   detectsUsingLOS = false;
   detectsPassiveJammed = false;
   detectsActiveJammed = false;
   detectsCloaked = false;
   detectionPings = false;
   detectRadius = 45;
   
   jams = true;
   jamsOnlyGroup = false;
   jamsUsingLOS = false;
   jamRadius = 50;
};

function SensorJamMod::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("SensorJamMod", 0);
     %vehicle.augmented = true;

     setTargetSensorData(%vehicle.target, VehicleJammerSensor);
}
