//--------------------------------------------------------------------------
// Vehicle Cloaking Module
//--------------------------------------------------------------------------

datablock ShapeBaseImageData(vehicleStandardModImage)
{
   mass = 0;

   shapeFile  = "pack_barrel_mortar.dts";
   item       = vehicleStandardMod;
   mountPoint = 1;
   offset     = "0 0 0";

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeOut[2] = "Idle";

	isLarge = true;
};

datablock ItemData(vehicleStandardMod)
{
   className    = Pack;
   catagory     = "Packs";
   shapeFile    = "pack_barrel_mortar.dts";
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
   rotate       = true;
   image        = "vehicleStandardModImage";
	pickUpName = "a cloaking gun";
};

function vehicleStandardModImage::onActivate(%data, %obj, %slot)
{
   // search for a vehicle in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a vehicle base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);

   if(%potVehicle != 0)    // positon of the vehicle
   {
          if(%potVehicle.getDatablock().getName() $= "ScoutFlyer") // Shrike Filter
          {
             // Not already augmented...
		   messageClient(%obj.client, 'MsgAugMount', "\c2Weapon Barrel Changed -> Shrike -> Cloaking Gun");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
             vehicleStandardMod::ApplyMod(%data, %obj, %potVehicle);
          }
          else
          {
             messageClient(%obj.client, 'MsgNotVehicle', "\c2Error! You cannot change weapons on this vehicle.");
             %obj.setImageTrigger($BackpackSlot, false);
          }
   }
   else
   {
      // I don't see any vehicle
      messageClient(%obj.client, 'MsgNoVehicle', "\c2No vehicle within the 5m range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

function vehicleStandardModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function vehicleStandardMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(CloakGunImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlePoint.dts";
   item      = Chaingun;
   mountPoint = 10;
   offset = "0 0 0";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 15;
   fireEnergy = 15;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
   stateTimeoutValue[0]             = 0.01;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
   stateTransitionOnTriggerDown[1]  = "Cloak";

   stateName[2]                     = "Cloak";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
   stateScript[2]                   = "onCloak";
   stateTransitionOnTriggerUp[2]    = "Decloak";
   stateTransitionOnNoAmmo[2]       = "Decloak";
//   stateSound[2]                    = CloakingPackActivateSound;

   stateName[3]                     = "NoAmmo";
   stateTransitionOnAmmo[3]         = "Ready";

   stateName[4]                     = "DeCloak";
   stateScript[4]                   = "onDecloak";
   stateTimeoutValue[4]             = 0.01;
   stateTransitionOnTimeout[4]      = "Ready";
};

datablock ShapeBaseImageData(CloakGunParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";
};

function checkStillCloaked(%obj)
{
     if(%obj.HoldingCloakTrigger)
     {
          %obj.useEnergy(10);
          schedule(500, 0, "checkStillCloaked", %obj);
     }
}

function CloakGunImage::onCloak(%data,%obj,%slot)
{
     %obj.setCloaked(true);
     %obj.getMountedObject(0).setCloaked(true);
     %obj.HoldingCloakTrigger = true;
     checkStillCloaked(%obj);
}

function CloakGunImage::onDecloak(%data,%obj,%slot)
{
     %obj.setCloaked(false);
     %obj.getMountedObject(0).setCloaked(false);
     %obj.HoldingCloakTrigger = false;
}

function vehicleStandardMod::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("vehicleStandardMod", 0);

     %vehicle.unmountImage(0);
     %vehicle.unmountImage(2);
     %vehicle.unmountImage(3);

     %vehicle.mountImage(CloakGunParam, 0);
     %vehicle.mountImage(CloakGunImage, 2);
     %vehicle.mountImage(CloakGunImage, 3);
     %vehicle.nextWeaponFire = 2;
}
