//--------------------------------------
// Particle Accelerator Cannon
//--------------------------------------

datablock AudioProfile(PACFireSound)
{
   filename    = "fx/vehicles/bomber_turret_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock LinearFlareProjectileData(ChargeBolt)
{
   radiusDamageType    = $DamageType::BellyTurret;

   sound               = discProjectileSound;

   explosion           = "PlasmaBoltExplosion";
   splash              = DiscSplash;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3500;
   lifetimeMS        = 3500;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "0.01 0.01 0.01";
   numFlares         = 30;
   flareColor        = "0.5 0.32 0.5";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/shrikeBoltCross";
};

function ChargeBolt::onExplode(%data, %proj, %pos, %mod)
{
      RadiusExplosion(%proj, %pos, %proj.radius, %proj.damage, %proj.kick, %proj.sourceObject, %data.radiusDamageType);
}

datablock LinearFlareProjectileData(ChargeFXBolt1)
{
   explosion           = "PlasmaBoltExplosion";
   splash              = DiscSplash;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3500;
   lifetimeMS        = 3500;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "1.0 1.0 1.0";
   numFlares         = 30;
   flareColor        = "0.5 0.32 0.5";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/shrikeBoltCross";
};

datablock LinearFlareProjectileData(ChargeFXBolt2) : ChargeFXBolt1
{
   scale             = "2.0 2.0 2.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt3) : ChargeFXBolt1
{
   scale             = "3.0 3.0 3.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt4) : ChargeFXBolt1
{
   scale             = "4.0 4.0 4.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt5) : ChargeFXBolt1
{
   scale             = "5.0 5.0 5.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt6) : ChargeFXBolt1
{
   scale             = "6.0 6.0 6.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt7) : ChargeFXBolt1
{
   scale             = "7.0 7.0 7.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt8) : ChargeFXBolt1
{
   scale             = "8.0 8.0 8.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt9) : ChargeFXBolt1
{
   scale             = "9.0 9.0 9.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt10) : ChargeFXBolt1
{
   scale             = "10.0 10.0 10.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt11) : ChargeFXBolt1
{
   scale             = "11.0 11.0 11.0";
};

datablock LinearFlareProjectileData(ChargeFXBolt12) : ChargeFXBolt1
{
   scale             = "12.0 12.0 12.0";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(LaserCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_grenade.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a particle accelerator capacitor";

   emap = true;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(ChargeRifle)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_sniper.dts";
   image = ChargeRifleImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a particle accelerator cannon (PAC)";
};

datablock ShapeBaseImageData(ChargeRifleImage)
{
   className = WeaponImage;
   shapeFile = "weapon_sniper.dts";
   item = ChargeRifle;
   ammo = LaserCapacitor;
   offset = "0 0 0";
   emap = true;

   offset = "0 0.2 0.05";
   emap = true;
   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";

   stateName[2]                     = "Fire";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
   stateScript[2]                   = "onFire";
   stateTransitionOnTriggerUp[2]    = "Deconstruction";

   stateName[3]                     = "Deconstruction";
   stateScript[3]                   = "onRelease";
   stateTimeoutValue[3]             = 0.5;
   stateTransitionOnTimeout[3]      = "Ready";
};

function CLFire(%data, %player, %charge, %CL, %radius, %isCL, %dmg)
{
   %data.lightStart = getSimTime();

   if(!%player.getMountedImage(0) == %isCL)
        return false;

     if(%charge <= 15)
          %chgProj = "ChargeFXBolt1";
     else if(%charge <= 25)
          %chgProj = "ChargeFXBolt2";
     else if(%charge <= 45)
          %chgProj = "ChargeFXBolt3";
     else if(%charge <= 55)
          %chgProj = "ChargeFXBolt4";
     else if(%charge <= 65)
          %chgProj = "ChargeFXBolt5";
     else if(%charge <= 70)
          %chgProj = "ChargeFXBolt6";
     else if(%charge <= 85)
          %chgProj = "ChargeFXBolt7";
     else if(%charge <= 90)
          %chgProj = "ChargeFXBolt8";
     else if(%charge <= 115)
          %chgProj = "ChargeFXBolt9";
     else if(%charge <= 130)
          %chgProj = "ChargeFXBolt10";
     else if(%charge <= 145)
          %chgProj = "ChargeFXBolt11";
     else
          %chgProj = "ChargeFXBolt12";

   %p = new LinearFlareProjectile()
   {
          dataBlock        = "ChargeBolt";
          initialDirection = %player.getMuzzleVector(%CL);
          initialPosition  = %player.getMuzzlePoint(%CL);
          sourceObject     = %player;
          sourceSlot       = %CL;
          radius           = %radius;
          damage           = %dmg;
          kick             = (%charge*6);
          scale            = %scale;
          vehicleObject    = 0;
   };

     %player.lastProjectile = %p;
     MissionCleanup.add(%p);

     %p.radius = %radius;
     %p.damage = %dmg;
     %p.kick = (%charge*6);
     %p.setScale(%scale);
     %player.setInventory(%data.ammo,0);     // start from scratch

   %q = new LinearFlareProjectile()
   {
          dataBlock        = %chgProj;
          initialDirection = %player.getMuzzleVector(%CL);
          initialPosition  = %player.getMuzzlePoint(%CL);
          sourceObject     = %player;
          sourceSlot       = %CL;
          vehicleObject    = 0;
   };
   MissionCleanup.add(%q);


   // AI hook
   if(%player.client)
      %player.client.projectile = %p;

   serverPlay3D(PulseCannonFire, %player.getTransform()); //PACFireSound, %player.getTransform());
}

function CLCharge(%data, %player, %CL)       // should work....
{
     if(!isObject(%player))
          return;
     
     %ammo = %player.getInventory(%data.ammo);
     %ammoMax = %player.getDatablock().max["LaserCapacitor"];
     %CLOnHand = %player.getMountedImage(0);
     
     if(%player.CL)
     {
          if(%player.getMountedImage(0) == %CLOnHand)
          {
               %player.incInventory("LaserCapacitor", 1);

               if(%ammo > %ammoMax)
                    %ammo = %ammoMax;   // quick non-overcharge hack

               if(%player.isSyn)
                    schedule(100, 0, "CLCharge", %data, %player, %CL);
               else
                    schedule(200, 0, "CLCharge", %data, %player, %CL);
          }
     }
     else
     {
          if(%player.getMountedImage(0) == %CLOnHand)
          {
               %radius = %ammo / 2 * (1/3);
               %dmg = %ammo / 50;
               CLFire(%data, %player, %ammo, %CL, %radius, %CLOnHand, %dmg);
               return;
          }
     }
}

function ChargeRifleImage::onFire(%data,%obj,%slot) // Uses CL(tm) code
{
     if(!%obj.CL || !%obj.CL == true)
     {
          %ammo = %obj.getInventory(%data.ammo);
          %ammoMax = %obj.getDatablock().max["LaserCapacitor"];

          %obj.CL = true;
          %obj.incInventory(LaserCapacitor, 1);

          if(%obj.isSyn)
               schedule(100, 0, "CLCharge", %data, %obj, %slot);
          else
               schedule(200, 0, "CLCharge", %data, %obj, %slot);
     }
}

function ChargeRifleImage::onRelease(%data,%obj,%slot)
{
     %obj.CL = false;
}

